#!/usr/bin/env python

from simplex import *
import sys, time

try:
    separator = sys.argv.index("--")
    filename, numeric = sys.argv[1:3]
    fields = map(int, sys.argv[3:separator])
    terms = groups(sys.argv[separator+1:], len(fields))
except (IndexError, ValueError):
    print >>sys.stderr, "Usage: %s <filename> <field>... -- <term value>..." % sys.argv[0]
    sys.exit(1)

f = open(filename)
converters = [(numeric == "true" and int or None) for field in fields]
accessor = Converted(DelimitedRecord(fields), converters)
reader = TextFile(f, Iterator(accessor))

try:
    for term in terms:
        reader.seek(0)

        t = time.time()
        line = find_in_file(reader, accessor.convert(term))
        if line:
            print "Found (at %s seconds)...\n%s" % (time.time() - t, line)
finally:
    f.close()

# vim: tabstop=4 expandtab shiftwidth=4
